addpath('data')
addpath('mfile')

%% Example 1: Chinese Lion

load('chinese_lion.mat');

% If you want to color your own mesh with curvature, please also run the following line:
% FV.vertices = v;
% FV.faces = f;
% mean_curv_ori = patchcurvature(FV);
% mean_curv = mean_curv_ori;
% mean_curv(mean_curv_ori > mean(mean_curv_ori)+1*std(mean_curv_ori)) =  mean(mean_curv_ori)+1*std(mean_curv_ori);
% mean_curv(mean_curv_ori < mean(mean_curv_ori)-1*std(mean_curv_ori)) =  mean(mean_curv_ori)-1*std(mean_curv_ori);

plot_mesh(v',f',mean_curv); view([0 80]);
title('Input Mesh')

vmap = diskmap(v,f);

plot_mesh(vmap',f',mean_curv); view([-25 90]);
title('Disk Conformal Parameterization of the Input Mesh')

%% Example 2: Human Face

load('human_face.mat')

plot_mesh(v',f',mean_curv); view([-90 -85]);
title('Input Mesh')

vmap = diskmap(v,f);

plot_mesh(vmap',f',mean_curv); view([-10 90]);
title('Disk Conformal Parameterization of the Input Mesh')

%% Example 3: Hand

load('hand.mat')

plot_mesh(v',f',mean_curv); view([40 70]);
title('Input Mesh')

vmap = diskmap(v,f);

plot_mesh(vmap',f',mean_curv); view([0 90]);
title('Disk Conformal Parameterization of the Input Mesh')

%% Example 4: Human Brain

load('human_brain.mat')

plot_mesh(v',f',mean_curv); view([90 0]);
title('Input Mesh')

vmap = diskmap(v,f);

plot_mesh(vmap',f',mean_curv); view([190 90]);
title('Disk Conformal Parameterization of the Input Mesh')
