function Operator = createOperator(v,f)

Operator.f2v = F2V(v,f);
if exist('laplace_beltrami') == 3
    % mex file is avaiable, which is much faster
    Operator.laplacian = laplace_beltrami(f',v','Polthier');
else
    % use the matlab code "laplacebeltrami", but it may be a bit slower
    Operator.laplacian = laplacebeltrami(v,f);
end

end

% -------------------------------------------------------
function S = F2V(v,f)
    ring = vertexAttachments(TriRep(f',v'));
    nv = length(v); nf = length(f);
    II = cellfun(@times,ring,num2cell(zeros(nv,1)),'UniformOutput',0);
    II = cell2mat(cellfun(@plus,II,num2cell(1:nv)','UniformOutput',0)')';
    JJ = cell2mat(ring')';
    avg = cellfun(@length,ring);
    S = sparse(II,JJ,ones(length(JJ),1),nv,nf);
    S = sparse(1:nv,1:nv,1./avg)*S;
end

