function L = laplacebeltrami(v,f)

l = [sqrt(sum((v(:,f(2,:)) - v(:,f(3,:))).^2,1));
    sqrt(sum((v(:,f(3,:)) - v(:,f(1,:))).^2,1));
    sqrt(sum((v(:,f(1,:)) - v(:,f(2,:))).^2,1))];
 
f1 = f(1,:); f2 = f(2,:); f3 = f(3,:);
l1 = l(1,:); l2 = l(2,:); l3 = l(3,:);

s = (l1 + l2 + l3)*0.5;
area = 2*sqrt( s.*(s-l1).*(s-l2).*(s-l3));
 
cot12 = (l1.^2 + l2.^2 - l3.^2)./area/4;
cot23 = (l2.^2 + l3.^2 - l1.^2)./area/4; 
cot31 = (l1.^2 + l3.^2 - l2.^2)./area/4; 
diag1 = -cot12-cot31; diag2 = -cot12-cot23; diag3 = -cot31-cot23;

II = [f1 f2 f2 f3 f3 f1 f1 f2 f3];
JJ = [f2 f1 f3 f2 f1 f3 f1 f2 f3];
V = [cot12' cot12' cot23' cot23' cot31' cot31' diag1' diag2' diag3'];
L = sparse(II,JJ,V,size(v,2),size(v,2));

end