function show_mesh(v,f,arg3)

if nargin < 3
    graph = figure; patch('Faces',f','Vertices',v','FaceColor','none',...
        'EdgeColor',[64,150,190]/255,'LineWidth',0.5);
else
    graph = figure; patch('Faces',f','Vertices',v','FaceColor','flat','FaceVertexCData',arg3,...
        'EdgeColor','k', 'LineWidth',0.1);
end
colormap('Spring');
caxis([2.7317 3.2188]);
axis equal
axis tight
axis('off');
set(gcf,'color','w'); 

assetData = struct('Vertex',v);
setappdata(gca,'AssetData',assetData);

dcm_obj = datacursormode(graph);
if size(v,1) < 3
    set(dcm_obj,'UpdateFcn',@ID_display,'Enable','on')
else set(dcm_obj,'UpdateFcn',@ID_display3D,'Enable','on');
end
end

function txt = ID_display(obj,event_obj)

hAxes = get(get(event_obj,'Target'),'Parent');
assetData = getappdata(hAxes,'AssetData');

pos = get(event_obj,'Position');
id = vertex_search([pos(1),pos(2)],assetData.Vertex);
txt = {['(x,y) : (',num2str(pos(1)),',',num2str(pos(2)),')'],...
    ['vertex ID : ',int2str(id)]};

end

function txt = ID_display3D(obj,event_obj)

hAxes = get(get(event_obj,'Target'),'Parent');
assetData = getappdata(hAxes,'AssetData');

pos = get(event_obj,'Position');
id = vertex_search3D([pos(1),pos(2),pos(3)],assetData.Vertex);
txt = {['(x,y,z) : (',num2str(pos(1)),',',num2str(pos(2)),',',num2str(pos(3)),')'],...
    ['vertex ID : ',int2str(id)]};

end
%% reference
%% http://www.mathworks.in/matlabcentral/answers/447